Attribute VB_Name = "SimOptModule"
Public Const COSTSTORE As Integer = 7
Public Const CONDCOST As Integer = 5

Public Const MOVECOST As Integer = 21
Public Const TURNCOST As Integer = 22
Public Const TIECOST As Integer = 23
Public Const SHOTCOST As Integer = 24
Public Const BPCYCCOST As Integer = 25
Public Const BPCOPYCOST As Integer = 26
Public Const VENOMCOST As Integer = 27
Public Const POISONCOST As Integer = 28
Public Const SLIMECOST As Integer = 29
Public Const SHELLCOST As Integer = 30
Public Const BODYUPKEEP As Integer = 31

' definition of the SimOpts structure

'BE VERY CAREFUL changing the TYPE of a variable
'the read/write functions for saving sim settings/bots/simulations are
'very particular about variable TYPE

Public Type SimOptions
  SimName As String
  TotRunCycle As Long
  CycSec As Long
  TotRunTime As Long
  TotBorn As Long
  SpeciesNum As Integer
  Specie(50) As datispecie
  FieldSize As Integer
  FieldWidth As Long
  FieldHeight As Long
  MaxPopulation As Integer
  MinVegs As Integer
  KillDistVegs As Boolean
  BlockedVegs As Boolean
  DisableTies As Boolean
  PopLimMethod As Integer
  
  'toroidal is updnconnected = dxsxconected = true
  Toroidal As Boolean
  Updnconnected As Boolean
  Dxsxconnected As Boolean
  '
  AutoSimPath As String
  AutoSimTime As Integer
  AutoRobPath As String
  AutoRobTime As Integer
  '
  MutCurrMult As Single
  MutOscill As Boolean
  MutCycMax As Long
  MutCycMin As Long
  '
  DBName As String
  DBEnable As Boolean
  DBExcludeVegs As Boolean
  DBRecDna As Boolean
  '
  F1 As Boolean
  League As Boolean
  Restart As Boolean
  
  UserSeedToggle As Boolean
  UserSeedNumber As Long
  
  MaxEnergy As Long
  ZeroMomentum As Boolean 'used to tell the simulation that robots don't get to keep velocity they've acquired.
   
  'obsolete
  CostExecCond As Single
  
  'above replaced by:
  Costs(70) As Single
  'first 20 costs 0..19 are for DNA types (that's right, an extra 9 slots for future types)
  
  'then it goes:
  'move cost = 20
  'turn cost = 21
  'tie cost = 22
  'shot cost = 23
  'cost per bp per cycle = 24
  'cost per bp per copy = 25
  'Lots of room for future costs
  
  Pondmode As Boolean
  LightIntensity As Integer
  Gradient As Single
  DayNight As Boolean 'the toggle
  Daytime As Boolean 'the variable
  CycleLength As Integer
  CorpseEnabled As Boolean
  Bouyancy As Boolean
  Decay As Single
  Decaydelay As Integer
  DecayType As Integer
  EnergyProp As Single
  EnergyFix As Integer
  EnergyExType As Boolean
  '
  CoefficientStatic As Single
  CoefficientKinetic As Single
  Zgravity As Single
  Ygravity As Single
  Density As Double
  Viscosity As Double
  FlowType As Byte
  '
  PhysBrown As Single
  PhysMoving As Single
  
  'swimming constant will hopefully soon be either obsolete or revamped.
  PhysSwim As Single
  
  PlanetEaters As Boolean
  PlanetEatersG As Single
    
  RepopCooldown As Integer
  RepopAmount As Integer
  
  Diffuse As Single
  VegFeedingMethod As Integer
  VegFeedingToBody As Single
End Type

Public SimOpts As SimOptions
Public TmpOpts As SimOptions
